# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from ._lib import ParamGroupWrapper, create_unique_id


@dataclass(kw_only=True)
class BoundaryLayerProfile(ParamGroupWrapper[clientpb.BoundaryLayerProfile]):
    """"""

    n_layers: int = 40
    "Maximum number of prism layers within a boundary layer mesh."
    initial_size: float = 1e-06
    "Size of the mesh layer nearest the boundary surface in meters."
    growth_rate: float = 1.2
    "Ratio of size between 2 successive boundary mesh layers."
    surfaces: list[str] = field(default_factory=list)
    ""

    def _to_proto(self) -> clientpb.BoundaryLayerProfile:
        _proto = clientpb.BoundaryLayerProfile()
        _proto.n_layers.value = self.n_layers
        _proto.initial_size.value = self.initial_size
        _proto.growth_rate.value = self.growth_rate
        if self.surfaces is not None:
            _proto.surfaces.extend(self.surfaces)
        return _proto

    def _from_proto(self, proto: clientpb.BoundaryLayerProfile) -> None:
        self.n_layers = proto.n_layers.value
        self.initial_size = proto.initial_size.value
        self.growth_rate = proto.growth_rate.value
        self.surfaces.extend(proto.surfaces)
        return None
