# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from ._lib import ParamGroupWrapper, create_unique_id


@dataclass(kw_only=True)
class MaterialSolid(ParamGroupWrapper[clientpb.MaterialSolid]):
    """Configuration for Solid materials"""

    density: float = 2700
    "Constant density value."
    specific_heat_cp: float = 896
    "Specific heat at constant pressure."
    thermal_conductivity: float = 167
    "The thermal conductivity of the material."

    def _to_proto(self) -> clientpb.MaterialSolid:
        _proto = clientpb.MaterialSolid()
        _proto.constant_density_value_solid.value = self.density
        _proto.specific_heat_cp_solid.value = self.specific_heat_cp
        _proto.thermal_conductivity_constant_solid.value = self.thermal_conductivity
        return _proto

    def _from_proto(self, proto: clientpb.MaterialSolid) -> None:
        self.density = proto.constant_density_value_solid.value
        self.specific_heat_cp = proto.specific_heat_cp_solid.value
        self.thermal_conductivity = proto.thermal_conductivity_constant_solid.value
        return None
