# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from ._lib import ParamGroupWrapper, create_unique_id


@dataclass(kw_only=True)
class SpatialDiscretizationHeat(ParamGroupWrapper[clientpb.SpatialDiscretizationHeat]):
    """Spatial discretization settings for a heat transfer physics solver."""

    gradient_method: enum.GradientMethod = enum.GradientMethod.HLSQ
    "Method for computing the spatial gradients of fluid variables."
    hlsq_blend: float = 1.7
    "Blending parameter in the hybrid least squares gradient methods in [1,2]."
    geometry_fixes: enum.GeometryFixes = enum.GeometryFixes.GEOMETRY_FIXES_ON
    "Strategies to cope with problematic mesh regions (e.g. high skewness angles)."
    geometry_fixes_mitigations: float = 0.25
    "Magnitude of the geometrical fixes mitigations. Expected value within [0,1]. The higher this value, the more numerical dissipation is added at control volumes with low-quality topological properties."

    def _to_proto(self) -> clientpb.SpatialDiscretizationHeat:
        _proto = clientpb.SpatialDiscretizationHeat()
        _proto.gradient_method = self.gradient_method
        _proto.hlsq_blend.value = self.hlsq_blend
        _proto.geometry_fixes = self.geometry_fixes
        _proto.geometry_fixes_mitigations.value = self.geometry_fixes_mitigations
        return _proto

    def _from_proto(self, proto: clientpb.SpatialDiscretizationHeat) -> None:
        self.gradient_method = enum.GradientMethod(proto.gradient_method)
        self.hlsq_blend = proto.hlsq_blend.value
        self.geometry_fixes = enum.GeometryFixes(proto.geometry_fixes)
        self.geometry_fixes_mitigations = proto.geometry_fixes_mitigations.value
        return None
