# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from ._lib import ParamGroupWrapper, create_unique_id

from .bc_komega_variables import BcKomegaVariables
from .bc_sa_variable import BcSaVariable
from .bc_turbulent_viscosity_and_intensity_komega import BcTurbulentViscosityAndIntensityKomega
from .bc_turbulent_viscosity_ratio_and_intensity_komega import (
    BcTurbulentViscosityRatioAndIntensityKomega,
)
from .bc_turbulent_viscosity_ratio_sa import BcTurbulentViscosityRatioSa
from .bc_turbulent_viscosity_sa import BcTurbulentViscositySa
from .komega_boundary_conditions import KomegaBoundaryConditions
from .spalart_allmaras_boundary_conditions import SpalartAllmarasBoundaryConditions


@dataclass(kw_only=True)
class TurbulenceBoundaryConditions:
    """Turbulence boundary conditions."""

    spalart_allmaras_boundary_conditions: SpalartAllmarasBoundaryConditions = field(
        default_factory=BcTurbulentViscosityRatioSa
    )
    "Condition applied to the Spalart-Allmaras turbulence equation at the boundary."
    komega_boundary_conditions: KomegaBoundaryConditions = field(
        default_factory=BcTurbulentViscosityRatioAndIntensityKomega
    )
    "Condition applied to the k-ω turbulence variables at the boundary."
